---
title: RTL Guidelines
slug: Mozilla/Developer_guide/RTL_Guidelines
tags:
  - Guide
  - rtl
---
<p>RTL languages such as Arabic, Hebrew, Persian and Urdu are read and written from right-to-left, and the user interface for these languages should be mirrored to ensure the content is easy to understand.</p>

<p>When a UI is changed from LTR to RTL (or vice-versa), it’s often called mirroring. An RTL layout is the mirror image of an LTR layout, and it affects layout, text, and graphics.</p>

<p>In RTL, anything that relates to time should be depicted as moving from right to left. For example, forward points to the left, and backwards points to the right.</p>

<h3 id="Mirroring_layout">Mirroring layout</h3>

<p>When a UI is mirrored, these changes occur:</p>

<ul>
 <li>Text fields icons are displayed on the opposite side of a field</li>
 <li>Navigation buttons are displayed in reverse order</li>
 <li>Icons that communicate direction, like arrows, are mirrored</li>
 <li>Text is usually aligned to the right</li>
</ul>

<p>In CSS, while it's possible to apply a rule for LTR and a separate one specifically for RTL, it's usually better to use CSS Logical Properties which provide the ability to control layout through logical, rather than physical mappings.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Do</th>
   <th scope="col">Don't do</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td dir="ltr"><code>{{cssxref("margin-inline-start")}}: 5px;</code></td>
   <td dir="ltr"><code>margin-left: 5px;</code></td>
  </tr>
  <tr>
   <td dir="ltr"><code>{{cssxref("padding-inline-end")}}: 5px;</code></td>
   <td dir="ltr"><code>padding-right: 5px;</code></td>
  </tr>
  <tr>
   <td dir="ltr"><code>{{cssxref("float")}}: inline-start;</code></td>
   <td dir="ltr"><code>float: left;</code></td>
  </tr>
  <tr>
   <td dir="ltr"><code>{{cssxref("inset-inline-start")}}: 5px;</code></td>
   <td dir="ltr"><code>left: 5px;</code></td>
  </tr>
  <tr>
   <td dir="ltr"><code>{{cssxref("border-inline-end")}}: 1px;</code></td>
   <td dir="ltr"><code>border-right: 1px;</code></td>
  </tr>
  <tr>
   <td dir="ltr"><code><a href="/en-US/docs/Web/CSS/border-start-end-radius">border-{start/end}-{start/end}-radius</a>: 2px;</code></td>
   <td dir="ltr"><code>border-{top/bottom}-{left/right}-radius: 2px;</code></td>
  </tr>
  <tr>
   <td dir="ltr"><code>{{cssxref("padding")}}: 1px 2px;</code></td>
   <td dir="ltr"><code>padding: 1px 2px 1px 2px;</code></td>
  </tr>
  <tr>
   <td dir="ltr"><code>{{cssxref("margin-block")}}: 1px 3px;</code> &amp;&amp; <code>{{cssxref("margin-inline")}}: 4px 2px;</code></td>
   <td dir="ltr"><code>margin: 1px 2px 3px 4px;</code></td>
  </tr>
  <tr>
   <td dir="ltr"><code>{{cssxref("text-align")}}: start;</code> or <code>text-align: match-parent;</code> (depends on the context)</td>
   <td dir="ltr"><code>text-align: left;</code></td>
  </tr>
 </tbody>
</table>

<p>When there is no special RTL-aware property available, or when left/right properies must be used specifically for RTL, use the pseudo <code>{{cssxref(":-moz-locale-dir(rtl)")}}</code> (for XUL files) or <code><a href="/en-US/docs/Web/CSS/:dir">:dir(rtl)</a></code> (for HTML files).<br>
 For example, this rule covers LTR to display searchicon.svg 7 pixels from the left:</p>

<pre class="brush: css">.search-box {
  background-image: url(chrome://path/to/searchicon.svg);
  background-position: 7px center;
}
</pre>

<p>but an additional rule is necessary to cover RTL and place the search icon on the right:</p>

<pre class="brush: css">.search-box:dir(rtl) {
  background-position-x: right 7px;
}
</pre>

<div class="notecard warning">
<p>Note that it may be inappropriate to use logical properties when embedding LTR within RTL contexts, this is described further in the document.</p>
</div>

<h3 id="Mirroring_elements">Mirroring elements</h3>

<p>RTL content also affects the direction in which some icons and images are displayed, particularly those depicting a sequence of events.</p>

<h4 id="What_to_mirror">What to mirror</h4>

<ul>
 <li>Icons that imply directionality like back/forward buttons</li>
 <li>Icons that imply text direction, like <a href="https://searchfox.org/mozilla-central/rev/74cc0f4dce444fe0757e2a6b8307d19e4d0e0212/browser/themes/shared/reader/readerMode.svg">readerMode.svg</a></li>
 <li>Icons that imply location of UI elements in the screen, like <a href="https://searchfox.org/mozilla-central/rev/74cc0f4dce444fe0757e2a6b8307d19e4d0e0212/browser/themes/shared/icons/sidebars-right.svg">sidebars-right.svg</a>, <a href="https://searchfox.org/mozilla-central/rev/74cc0f4dce444fe0757e2a6b8307d19e4d0e0212/browser/themes/shared/icons/open-in-new.svg">open-in-new.svg</a>, <a href="https://searchfox.org/mozilla-central/rev/a78233c11a6baf2c308fbed17eb16c6e57b6a2ac/toolkit/mozapps/extensions/content/default-theme.svg">default-theme.svg</a> or <a href="https://searchfox.org/mozilla-central/rev/74cc0f4dce444fe0757e2a6b8307d19e4d0e0212/devtools/client/debugger/images/pane-collapse.svg">pane-collapse.svg</a></li>
 <li>Icons representing objects that are meant to be handheld should look like they're being right-handed, like the <a href="https://searchfox.org/mozilla-central/rev/e7c61f4a68b974d5fecd216dc7407b631a24eb8f/toolkit/themes/windows/global/icons/search-textbox.svg">magnifying glass icon</a></li>
 <li>Twisties in collapsed state (in RTL context only)</li>
</ul>

<h4 id="What_NOT_to_mirror">What NOT to mirror</h4>

<ul>
 <li>Text/numbers</li>
 <li>Icons containing text/numbers</li>
 <li>Icons/animations that are direction neutral</li>
 <li>Icons that wouldn't look differently if they'd be mirrored, like <a href="https://searchfox.org/mozilla-central/rev/a78233c11a6baf2c308fbed17eb16c6e57b6a2ac/devtools/client/debugger/images/close.svg">X buttons</a> or the <a href="https://searchfox.org/mozilla-central/rev/a78233c11a6baf2c308fbed17eb16c6e57b6a2ac/browser/themes/shared/icons/bookmark-hollow.svg">bookmark star</a> icon</li>
 <li>Icons that should look the same as LTR, like icons related to code (which is always LTR) like <a href="https://searchfox.org/mozilla-central/rev/74cc0f4dce444fe0757e2a6b8307d19e4d0e0212/devtools/client/themes/images/tool-webconsole.svg">tool-webconsole.svg</a></li>
 <li>Checkmark icons</li>
 <li>Video/audio player controls</li>
 <li>Product logos</li>
 <li>Order of size dimensions (e.g., <code>1920x1080</code> should not become <code>1080x1920</code>)</li>
 <li>Order of size units (e.g., <code>10 px</code> should not become <code>px 10</code> (unless the size unit is localizable))</li>
</ul>

<h4 id="How">How</h4>

<p>The most common way is by flipping the X axis:</p>

<pre class="brush: css" dir="ltr">{{cssxref("transform")}}: <a href="/en-US/docs/Web/CSS/transform-function/scaleX">scaleX</a>(-1);</pre>

<h3 id="LTR_text_inside_RTL_contexts">LTR text inside RTL contexts</h3>

<p>By default, in RTL locales, some symbols like "/", "." will be moved around and won't be displayed in the order that they were typed in. This may be problematic for URLs for instance, where you don't want dots to change position.</p>

<p>Here's a non-exhaustive list of elements that should be displayed like they would be in LTR locales:</p>

<ul>
 <li>Paths (e.g., C:\Users\username\Desktop)</li>
 <li>Full URLs</li>
 <li>Code and code containers (like the DevTools' Inspector or the CSS rules panel)</li>
 <li>about:config preference names and values</li>
 <li>Telephone numbers</li>
 <li>Usernames &amp; passwords (most sites on the web expect LTR usernames/passwords, but there may be exceptions)</li>
 <li>Other text fields where only LTR text is expected</li>
</ul>

<p>To make sure these are displayed correctly, you can use one of the following on the relevant element:</p>

<ul>
 <li><code>direction: ltr</code></li>
 <li><code>dir="ltr"</code> in HTML</li>
</ul>

<p>Since the direction of such elements is forced to LTR, the text will also be aligned to the left, which is undesirable from an UI perspective, given that is inconsistent with the rest of the RTL UI which has text usually aligned to the right. You can fix this using <code>text-align: match-parent</code>. In the following screenshot, both text fields (username and password) and the URL have their direction set to LTR (to display text correctly), but the text itself is aligned to the right for consistency with the rest of the UI:</p>

<p><img alt="about:logins textboxes in RTL layout" src="https://mdn.mozillademos.org/files/16969/about-logins-rtl.png" style="height: 280px; width: 300px;"></p>

<p>However, since the direction in LTR, this also means that the start/end properties will correspond to left/right respectively, which is probably not what you expect. This means you have to use extra rules instead of using logical properties.</p>

<p>Here's a full code example:</p>

<pre class="brush: css">.url {
  direction: ltr; /* Force text direction to be LTR */

  /* `start` (the default value) will correspond to `left`,
     so we match the parent's direction in order to align the text to the right */
  text-align: match-parent;
}

/* :dir(ltr/rtl) isn't meaningful on .url, since it has direction: ltr, hence why it is matched on .container. */
.container:dir(ltr) .url {
  padding-left: 1em;
}

.container:dir(rtl) .url {
  padding-right: 1em;
}
</pre>

<div class="notecard note">
<p>The LTR rule is seperate from the global rule to avoid having the left padding apply on RTL without having to reset it in the RTL rule.</p>
</div>

<h4 id="Auto-directionality">Auto-directionality</h4>

<p>Sometimes, the text direction on an element should vary dynamically depending on the situation. This can be the case for a search input for instance, a user may input a query in an LTR language, but may also input a query in a RTL language. In this case, the search input has to dynamically pick the correct directionality based on the first word, in order to display the query text correctly. The typical way to do this is to use <code>dir="auto"</code> in HTML. It is essential that <code>text-align: match-parent</code> is set, to avoid having the text alignment change based on the query, and logical properties also cannot be used on the element itself given they can change meaning depending on the query.</p>

<h3 id="Testing">Testing</h3>

<p>To test for RTL layouts in Firefox, you can go to about:config and set <span dir="auto"><code class="c-mrkdwn__code"><span class="c-mrkdwn__highlight">intl.l10n.pseudo</span></code> to <code class="c-mrkdwn__code">bidi</code></span> or <code>intl.uidirection</code> to <code>1</code>.<br>
 The Firefox UI should immediately flip, but a restart may be required to take effect in some Firefox features and interactions.</p>

<div class="notecard note">
<p>When testing with <code>intl.uidirection</code> set to <code>1</code>, you may see some oddities regarding text ordering due to the nature of displaying LTR text in RTL layout.</p>

<p><img alt="about:protections in RTL layour- English vs. Hebrew" src="https://mdn.mozillademos.org/files/16970/about-protections-rtl.png" style="height: 124px; width: 350px;"></p>

<p>This shouldn't be an issue when using an actual RTL locale or with <span dir="auto"><code class="c-mrkdwn__code"><span class="c-mrkdwn__highlight">intl.l10n.pseudo</span></code> set to <code class="c-mrkdwn__code">bidi</code> .</span></p>
</div>

<h4 id="How_to_spot_RTL-related_issues">How to spot RTL-related issues</h4>

<ul>
 <li>Punctuation marks should appear on the left side of a word/sentence/paragraph on RTL, so if a <em>localizable</em> string appears in the UI with a dot, colon, ellipsis, question or exclamation mark on the right side of the text, this probably means that the text field is forced to be displayed as LTR.</li>
 <li>If icons/images/checkmarks do not appear on the opposite side of text, when compared to LTR</li>
 <li>If buttons (like the close button, "OK" and "Cancel" etc.) do not appear on the opposite side of the UI and not in the opposite order, when compared to LTR</li>
 <li>If paddings/margins/borders are not the same from the opposite side, when compared to LTR</li>
 <li>If on an Arabic or Persian build, digits are displayed as <code>1 2 3</code> and not <code>١ ٢ ٣</code> (note that Hebrew uses <code>1 2 3</code>)</li>
 <li>If navigating in the UI using the left/right arrow keys does not select the correct element (i.e., pressing Left selects an item on the right)</li>
 <li>If navigating in the UI using the Tab key does not focus elements from right to left, in an RTL context</li>
 <li>If code is displayed as RTL (e.g., <code>;padding: 20px</code> - the semicolon should appear on the right side of the code). Code can still be aligned to the right if it appears in an RTL context</li>
</ul>

<h3 id="See_Also">See Also</h3>

<ul>
 <li><a href="https://docs.google.com/document/d/1Rc8rvwsLI06xArFQouTinSh3wNte9Sqn9KWi1r7xY4Y/edit#heading=h.pw54h41h12ct">RTL Best Practices</a></li>
 <li>Building RTL-Aware Web Apps &amp; Websites: <a href="https://hacks.mozilla.org/2015/09/building-rtl-aware-web-apps-and-websites-part-1/">Part 1</a>, <a href="https://hacks.mozilla.org/2015/10/building-rtl-aware-web-apps-websites-part-2/">Part 2</a></li>
</ul>

<h3 id="Credits">Credits</h3>

<p>Google's <a href="https://material.io/design/usability/bidirectionality.html">Material Design guide for RTL</a><br>
  </p>
